import java.util.HashMap;
import java.util.LinkedList;

public class RPNCalculator {

    public static final String END_TOKEN = "=";

    public static final String MUL = "*";
    public static final String DIV = "/";
    public static final String ADD = "+";
    public static final String SUB = "-";
    public static final String POW = "^";
    public static final String NEG = "~";

    /**
     * Stores a precedence value for each operator
     */
    public static HashMap<String, Integer> operatorPrecedence = new HashMap<String, Integer>();

    static {
        operatorPrecedence.put(POW, 4);
        operatorPrecedence.put(NEG, 3);
        operatorPrecedence.put(MUL, 2);
        operatorPrecedence.put(DIV, 2);
        operatorPrecedence.put(ADD, 1);
        operatorPrecedence.put(SUB, 1);
    }


    /**
     * Check if the given token is a RPN operator.
     * @param token the input token
     * @return
     */
    public static boolean isOperator(String token) {
        return operatorPrecedence.containsKey(token);
    }

    /**
     * Checks if the given token is the evaluation token =
     * @param token the input token
     * @return
     */
    public static boolean resultToken(String token) {
        return token.equals(END_TOKEN);
    }

    // CLASS BEGINS

    //TODO: Add a field, which references the internal Stack of the RPN Calculator

    //TODO: Add a Constructor, which initializes an empty internal stack

    /**
     * Checks if the given token is right associative.
     * In our example only the power operation is right associative.
     * @param token the input token
     * @return
     */
    public static boolean isRightAssociative(String token) {
        return token.equals(POW);
    }

    /**
     * Returns an array of values, which are currently in the RPN stack.
     * The top-most element is the first element in the array, and the following elements are ordered top-down.
     * Example:
     * Top -> 3
     *        1
     *        2
     * output: [3, 1, 2]
     * @return an array representation of the current RPN stack.
     */
    public double[] getCurrentStack() {
        //TODO
        return null;
    }

    /**
     * Pushes a value to the top of the RPN stack.
     * @param value the value to store
     */
    public void pushValue(double value) {
        //TODO
    }

    /**
     * This method evaluates the input operation on the RPN stack.
     * Example Input Operation: "+"
     * Top -> 3
     *        1
     *        2
     * After the operation is applied:
     * Top -> 4
     *        2
     * @param cmd a valid operation token
     * @throws RPNException if cmd is not a valid RPN operator or if there is a division by zero.
     */
    public void applyOperator(String cmd) throws RPNException {
        //TODO
        switch (cmd) {
            case NEG:
                //TODO
                break;
            //TODO
            default:
                throw new RPNException("Operation is not supported");
        }
    }

    /**
     * Returns but NOT removes the top-most element on the RPN stack
     * @return
     * @throws RPNException if the RPN stack is empty.
     */
    public double getResult() throws RPNException {
        //TODO
        return 0.0;
    }

    /**
     * Returns and removes the top-most element on the RPN stack
     * @return
     * @throws RPNException if the RPN stack is empty.
     */
    public double popResult() throws RPNException {
        //TODO
        return 0.0;
    }

    /**
     * Returns the current stack size.
     * @return
     */
    public int getStackSize() {
        //TODO
        return 0;
    }
}
